/*
 ******************************************************************************
 *
 *	ParcPlace Systems, Inc.
 *	Copyright (c) 1990, ParcPlace Systems, Inc. USA   All rights reserved.
 *
 ****************************************************************************
 *
 *	File:	pyrctmnu.H
 *
 *	Functions(s):
 *
 *	Description:
 *		OI_poly_rect_menu class header
 *
 *	RCSid = "$Id: pyrctmnu.H,v 4.2.1.1 1993/06/01 22:56:20 mth Exp $"
 *
 ****************************************************************************
 */

#ifndef OI_pyrctmnu_H
#define OI_pyrctmnu_H

#ifndef OI_pymnu_H
#include <OI/pymnu.H>
#endif /* OI_pymnu_H */

	// class forward reference declaration
	class OI_mdl_poly_rect_menu;

	class OI_poly_rect_menu : public OI_poly_menu {
			OI_mdl_poly_rect_menu	*mdl_dep ;
	 public:
		static	OI_class		*clsp ;			/* ptr to class record */
	 private:
			void			construct(OI_number, OI_menu_cell**) ;
	 protected:
						OI_poly_rect_menu(OI_class *, const char *, OI_number, OI_menu_cell **,
							OI_orient =OI_VERTICAL, const char * =NULL) ;
						OI_poly_rect_menu(OI_class *, const char *, OI_number, OI_cell_spec *,
							OI_orient =OI_VERTICAL, const char * =NULL) ;
		virtual	void			new_model(OI_model_type) ;
         public:
		//-------------------------------------------------------------------------------------------------		
		//		
		//	RESTRICTED MEMBER FUNCTIONS
		//		Functions in this section are not documented in the programmer's manual and are
		//		restricted to internal use by the toolkit.
		//		Functions not contained in user documentation are subject to change without notice
		//		and should never be used by toolkit users.
		//		Please maintain alphabetical order to facilitate releases and documentation.
		//
		//-------------------------------------------------------------------------------------------------		
						OI_poly_rect_menu(const char *, OI_number, OI_menu_cell **, OI_orient =OI_VERTICAL,
							const char * =NULL) ;
						OI_poly_rect_menu(const char *, OI_number, OI_cell_spec *, OI_orient =OI_VERTICAL,
							const char * =NULL) ;
						~OI_poly_rect_menu() ;
		virtual	PIXEL			cell_bkg_paint_pixel(OI_menu_cell *);
		virtual	PIXEL			cell_fg_paint_pixel(OI_menu_cell *);
		virtual	PIXEL			cell_fg_reverse_paint_pixel(OI_menu_cell *);
		virtual	void			cell_focus_in(OI_menu_cell*);
		virtual	void			cell_focus_out(OI_menu_cell*);
		virtual	void			cell_paint(OI_menu_cell *) ;
		virtual	void			cell_set_xtra(OI_menu_cell *);
		static	OI_bool			init(OI_connection*) ;
		static	OI_poly_rect_menu	*make_minimal(const char*,OI_minimal_type) ;
 		virtual	void			original_state(OI_bool = OI_YES);	/* Reset to before interaction start*/
		virtual	OI_stat			set_trigger(OI_number, OI_number=0) ;
		virtual	OI_menu_cell		*find_major_cell(int, int);		/* Check if major axis co ord corresponds to a cell. */

		//-------------------------------------------------------------------------------------------------		
		//		
		//	OVERRIDES OF DOCUMENTED PARENT MEMBER FUNCTIONS	
		//		Functions in this section are documented in the programmer's manual under the
		//		parent(s) of this object and are also available to the toolkit users.
		//		Please maintain alphabetical order to facilitate releases and documentation.
		//
		//-------------------------------------------------------------------------------------------------		

		//-------------------------------------------------------------------------------------------------		
		//		
		//	DOCUMENTED MEMBER MEMBER FUNCTIONS	
		//		Functions below this point are documented in the programmer's manual under this
		//		object and are available to the toolkit users.
		//		Please maintain alphabetical order to facilitate releases and documentation.
		//
		//-------------------------------------------------------------------------------------------------		
	} ;

//-------------------------------------------------------------------------------------------------		
//		
//	RESTRICTED FUNCTIONS
//		Functions in this section are not documented in the programmer's manual and are
//		restricted to internal use by the toolkit.
//		Functions not contained in user documentation are subject to change without notice
//		and should never be used by toolkit users.
//		Please maintain alphabetical order to facilitate releases and documentation.
//
//-------------------------------------------------------------------------------------------------		

//-------------------------------------------------------------------------------------------------		
//		
//	DOCUMENTED FUNCTIONS	
//		Functions below this point are documented in the programmer's manual under this
//		object and are available to the toolkit users.
//		Please maintain alphabetical order to facilitate releases and documentation.
//
//-------------------------------------------------------------------------------------------------		

#endif /* OI_pyrctmnu_H */
